/*
 * Created on 02-jun-2005
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.gvsig.geoprocessing.operations;

import java.util.BitSet;
import java.util.Vector;

import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.GeometryCollection;
import com.vividsolutions.jts.geom.GeometryFactory;
import com.vividsolutions.jts.geom.LineSegment;
import com.vividsolutions.jts.geom.LineString;
import com.vividsolutions.jts.geom.LinearRing;

/**
 * @author jmorell
 */
public final class GeoProcessingTopologyOperations {
    public static Geometry[] makeBuffers(Geometry[] geometries, double[] bufferDistances, int quadrantSegments) {
        Geometry[] buffers = new Geometry[geometries.length];
        for (int i=0;i<geometries.length;i++) {
            Geometry geometry = geometries[i];
            buffers[i] = geometry.buffer(bufferDistances[i], quadrantSegments);
        }
        return buffers;
    }
    public static Geometry makeDissolveBuffer(Geometry[] geometries, double bufferDistance, int quadrantSegments) {
        GeometryFactory geometryFactory = new GeometryFactory();
        GeometryCollection geometryCollection = new GeometryCollection(geometries,
                geometryFactory);
        Geometry geometryCollectionBuffer = geometryCollection.buffer(bufferDistance, quadrantSegments);
        return geometryCollectionBuffer;
    }
    public static Geometry makeDissolveBuffer(Geometry[] geometries, double[] bufferDistances, int quadrantSegments) {
        Geometry[] buffers = new Geometry[geometries.length];
        for (int i=0;i<geometries.length;i++) {
            Geometry geometry = geometries[i];
            buffers[i] = geometry.buffer(bufferDistances[i], quadrantSegments);
        }
        GeometryFactory geometryFactory = new GeometryFactory();
        GeometryCollection geometryCollection = new GeometryCollection(buffers,
                geometryFactory);
        // Hago un buffer con d=0 solo para poder devolver un POLYGON y no una GEOMETRYCOLLECTION
        // Molara conseguir el mismo efecto de una manera ms ortodoxa ... investigar ...
        Geometry geometryCollectionBuffer = geometryCollection.buffer(0);
        System.out.println("geometryCollection = " + geometryCollection);
        return geometryCollectionBuffer;
    }
}
